    Member()
    Map
      Include('JJKOLE.INC', 'OLEPROTOTYPES')
      module('api')
        lstrcpy(long,long),long,proc,pascal,raw,name('lStrCpyA')
        ShGetSpecialFolderLocation(unsigned hwnd, long specialLocation, *long lpPidl),pascal,long,proc
        ShGetPathFromIDList(long lpPidl, *cstring szPath),pascal,long,proc,raw,name('ShGetPathFromIDListA')
      end
      CreateShortCut(ShortCutStructType ShortCutStruct),byte
    end

!include general OLE equates
Include('JJKOLE.INC','OLEEQUATES')
Include('IShellLk.inc','IShellLkEquates'

!Equates for Return code
Return:Benign   equate(0)
Return:fatal    equate(3)
Return:Notify   equate(5)

!IShellLink Specific Data
Include('IShellLk.inc','IShellLkData')

CreateShortcut Procedure(ShortCutStructType SCS)
hr                      Long,auto !ole result code <0 = error
ppVtable_IShellLink     Long(0)   !pointer to a pointer to a vtable for IShellLink
ppVtable_IPersistFile   Long(0)
LinkFileName            cstring(File:MaxFilePath)
szPath                  cstring(File:MaxFilePath)
wszLinkFile             ushort,dim(File:MaxFilePath)
Res                     byte(0)
lpPidl                  long,auto
   code
   !Validate the required data pointers
   if ~SCS.lpTarget or ~SCS.lpIconPath or ~SCS.lpLinkFileName then
     Return(Return:Notify)
   end

   !Copy and check the link file name. If it includes a path,
   ! disregard the Special location
   ! Copy by specifying the address of both cstrings:
   lstrcpy(Address(LinkFileName),SCS.lpLinkFileName)
   If Instring('\',LinkFileName,1,1) or Instring(':',LinkFileName,1,1) then
     !LinkFileName includes a path
     SCS.SpecialLocation=-1
   end


   !init ole if not done already
   If InitOle() then Return(Return:Fatal).

   !Get the IShellLink ppVtable
   hr = CoCreateInstance( Address(CLSID_ShellLink), NULL, |
        CLSCTX_INPROC_SERVER, Address(IID_IShellLink),|
        ppVtable_IShellLink)
   if hr<0 then
     Return(Return:fatal)
   End



   !lets get the other interface we need Ipersist
   !Get IPersistFile Interface so we can save the file
   hr = ICall2p(ppVtable_IShellLink, IShellLink_QuerryInterface, Address(IID_IPersistFile), Address(ppVtable_IPersistFile))
   If hr<0 then
     Clear(ppVtable_IPersistFile)
     Res = Return:Fatal
     Do ProcedureReturn
   end

   !Set Short Cut Attributes
   ICall1p(ppVtable_IShellLink, IShellLink_SetPath, SCS.lpTarget)
   ICall2p(ppVtable_IShellLink, IShellLink_SetIconLoc, SCS.lpIconPath, SCS.IconIndex)
   If SCS.lpDesc then
     ICall1p(ppVtable_IShellLink, IShellLink_SetDescrip, SCS.lpDesc)
   end
   If SCS.hotkey then
     ICall1p(ppVtable_IShellLink, IShellLink_SetHotKey, SCS.HotKey)
   end
   If SCS.lpWorkingDir then
     ICall1p(ppVtable_IShellLink, IShellLink_SetWorkDir, SCS.lpWorkingDir)
   end

    !Now all that is left is saving the .lnk file to disk and telling windows
    ! if it should go in a conventional path or a SpecialLocation like the desktop
    If SCS.SpecialLocation<0 then
       !It's just a normal file/path so copy it to szPath
       szPath = LinkFileName
    Else
       !Lets ask the shell what the special location's Path is:
       !PILD = pointer to a Identifier List
       hr = ShGetSpecialFolderLocation(0,SCS.SpecialLocation,lppidl)
       If hr<0 then
         Res = Return:Fatal
         Do ProcedureReturn
       end

       !Now get a path from the pidl
       Hr = ShGetPathFromIDList(lpPidl,szPath)
       If hr<0 then
         Res = Return:Fatal
         Do ProcedureReturn
       end

       !put the path we just got together with the working directory
       If sub(szPath,-1,1)<>'\' then
         szPath = szPath & '\' & LinkFileName
       Else
         szPath = szPath & LinkFileName
       end
    end


    !Either way szPath is now the cstring where we want to store things
    !Now convert to a wide string
    MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED, szPath, -1, Address(wszLinkFile), File:MaxFilePath);

    !Last but not least, save the shortcut to disk then cleanup and exit:
    hr = ICall2p(ppVtable_IPersistFile, IPersistFile_Save, Address(wszLinkFile), True)
    ! The True above means clear the file is dirty flag, Would be false if this was a SaveAs
    if hr<0 then
        Res = Return:Fatal
    end
    Do ProcedureReturn



ProcedureReturn Routine
  if ppVtable_IPersistFile then
    iCall0P(ppVtable_IPersistFile,IPersistFile_Release)
  end
  If ppVtable_IShellLink then
    iCall0P(ppVtable_IShellLink,IShellLink_Release)
  end
  Return(Res)


